﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Management.Automation;
using System.Collections.ObjectModel;
using System.Management.Automation.Runspaces;
using System.Threading;
using System.Drawing;
using Microsoft.ConfigurationManagement.ManagementProvider;
using Microsoft.ConfigurationManagement.ManagementProvider.WqlQueryEngine;
using System.IO;
using System.Management;

namespace SoftwareUpdateTool
{
    public partial class frmSUPTool : Form
    {
        string fName = "";
        string Domain = Environment.UserDomainName;
        string strPSScript = "";
        public frmSUPTool()
        {
            InitializeComponent();

        }

        private void btnSelectScript_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
            txtScriptPath.Text = openFileDialog1.FileName.ToString();
        }

        private void btnCheckScript_Click(object sender, EventArgs e)
        {
            checkScript();
            //displayScript();
        }



        private void checkScript()
        {
            fName = txtScriptPath.Text;
            if (System.IO.File.Exists(fName))
                {
                    System.IO.StreamReader objReader = new System.IO.StreamReader(fName);
                int i = 0;
                    do
                    {
                        string textLine = objReader.ReadLine();
                        if (textLine != "")
                        {
                           
                            dataGridView1.Rows.Add();
                            string[] splitLine = textLine.Split(',');
                            string collname = splitLine[0];
                            string ADname = splitLine[1];
                            string SUGname = splitLine[2];

                            dataGridView1.Rows[i].Cells[0].Value = collname;
                            dataGridView1.Rows[i].Cells[1].Value = ADname;
                            dataGridView1.Rows[i].Cells[2].Value = SUGname;

                            if (checkLine(collname,ADname) == false)
                                    dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.Red;
                            else
                                dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.LightGreen;
                        }

                        i++;
                    } while (objReader.Peek() != -1);
                    objReader.Close();
                }
                
        }

        private bool checkLine(string day, string group)
        {
            string[] splDay = day.Split('-');
            string[] splGroup = group.Split('-');
            bool testDay = false;
            bool testGroup = false;

            //time
            if (splDay[3].Trim() == splGroup[3].Trim()) testDay = true;
            //day
            if (splDay[2].Trim() == "Sunday" && (splGroup[2].Trim().Trim() == "01" ||splGroup[2].Trim().Trim() == "08")) testGroup = true;
            if (splDay[2].Trim() == "Monday" && (splGroup[2].Trim() == "02" || splGroup[2].Trim() == "09")) testGroup = true;
            if (splDay[2].Trim() == "Tuesday" && (splGroup[2].Trim() == "03" || splGroup[2].Trim() == "10")) testGroup = true;
            if (splDay[2].Trim() == "Wednesday" && (splGroup[2].Trim() == "04" || splGroup[2].Trim() == "11")) testGroup = true;
            if (splDay[2].Trim() == "Thursday" && (splGroup[2].Trim() == "05" || splGroup[2].Trim() == "12")) testGroup = true;
            if (splDay[2].Trim() == "Friday" && (splGroup[2].Trim() == "06" || splGroup[2].Trim() == "13")) testGroup = true;
            if (splDay[2].Trim() == "Saturday" && (splGroup[2].Trim() == "07" || splGroup[2].Trim() == "14")) testGroup = true;

            if (testDay == false || testGroup == false) return false;
            return true;
        }



        private void btnRunScript_Click(object sender, EventArgs e)
        {
            
            string strColl = "";
            string strADGrp = "";
            string strSUG = "";
            string strQuery = "";
            string strQueryName = "";
            string strExceptionGroup = "";

            if(Environment.UserDomainName == "NETACPT")
                strExceptionGroup = @"NETACPT\\WTR-SCCM NPD-Exception";
            else
                strExceptionGroup = @"NETDOM\\WTR-SCCM WPR-Exception";

            lblExceptionGrp.Text = "Exception Group : " + strExceptionGroup;

            for (int i = 0; i < dataGridView1.RowCount; i++)
            {
                
                strColl = dataGridView1.Rows[i].Cells[0].Value.ToString();
                string[] strArrQueryName = strColl.Split(new string[] { "s - " }, StringSplitOptions.RemoveEmptyEntries);
                strQueryName = strArrQueryName[1];
                //MessageBox.Show(strQueryName);

                strADGrp = dataGridView1.Rows[i].Cells[1].Value.ToString();
                strSUG = dataGridView1.Rows[i].Cells[2].Value.ToString();
                strQuery = "select SMS_R_SYSTEM.ResourceID,SMS_R_SYSTEM.ResourceType,SMS_R_SYSTEM.Name,SMS_R_SYSTEM.SMSUniqueIdentifier,SMS_R_SYSTEM.ResourceDomainORWorkgroup,SMS_R_SYSTEM.Client from SMS_R_System where SMS_R_System.SystemGroupName = '" + strADGrp + "' and SMS_R_System.Name not in (select distinct SMS_R_System.Name from  SMS_R_System where SMS_R_System.SystemGroupName = '" + strExceptionGroup + "')";

                CreateDynamicCollection(WMIConn(), strColl, "", true, strQuery, strQueryName, "SMS00001", chkMonthlyPatches.Checked, chkCollections.Checked,chkMembership.Checked);

              //  ConfigureAndDeploySUMUpdates(WMIConn(),true,
            }
        }







        public void CreateDynamicCollection(WqlConnectionManager connection, string newCollectionName, string newCollectionComment, bool ownedByThisSite, string query, string ruleName, string LimitToCollectionID,bool PatchesOnly,bool CreateCollections,bool CreateQueries)
        {
            if (PatchesOnly) return;
            try
            {               
                // Create new SMS_Collection object.
                IResultObject newCollection = connection.CreateInstance("SMS_Collection");

                // Populate the new collection object properties.
                newCollection["Name"].StringValue = newCollectionName;
                newCollection["Comment"].StringValue = newCollectionComment;
                newCollection["OwnedByThisSite"].BooleanValue = ownedByThisSite;
                newCollection["LimitToCollectionID"].StringValue = LimitToCollectionID;

                // Save the new collection object and properties.
                // In this case, it seems necessary to 'get' the object again to access the properties.
                if (CreateCollections) newCollection.Put();
                newCollection.Get();

                // Validate the query.
                Dictionary<string, object> validateQueryParameters = new Dictionary<string, object>();
                validateQueryParameters.Add("WQLQuery", query);
                IResultObject result = connection.ExecuteMethod("SMS_CollectionRuleQuery", "ValidateQuery", validateQueryParameters);

                // Create query rule.
                IResultObject newQueryRule = connection.CreateInstance("SMS_CollectionRuleQuery");
                newQueryRule["QueryExpression"].StringValue = query;
                newQueryRule["RuleName"].StringValue = ruleName;

                // Add the rule. Although not used in this sample, QueryID contains the query identifier.
                Dictionary<string, object> addMembershipRuleParameters = new Dictionary<string, object>();
                addMembershipRuleParameters.Add("collectionRule", newQueryRule);
                IResultObject queryID = newCollection.ExecuteMethod("AddMembershipRule", addMembershipRuleParameters);

                // Start collection evaluator.
                newCollection.ExecuteMethod("RequestRefresh", null);
                txtInfo.Text = "Created collection: " + newCollectionName;
            }
            catch (SmsException ex)
            {
                txtInfo.Text = "Failed to create collection. Error: " + ex.Message;
                throw;
            }
        }


        public void ConfigureAndDeploySUMUpdates(WqlConnectionManager connection,
                                        bool newApplyToSubTargets,
                                        int[] newArrayAssignedCIs,
                                        int newAssignmentAction,
                                        string newAssignmentDescription,
                                        string newAssignmentName,
                                        int newDesiredConfigType,
                                        int newDPLocality,
                                        int newLocaleID,
                                        bool newLogComplianceToWinEvent,
                                        bool newNotifyUser,
                                        bool newRaiseMomAlertsOnFailure,
                                        bool newSendDetailedNonComplianceStatus,
                                        string newStartTime,
                                        int newSuppressReboot,
                                        string newTargetCollectionID,
                                        bool newUseGMTTimes)
        {
            try
            {

                // Create the deployment object.
                IResultObject newSUMUpdatesAssignment = connection.CreateInstance("SMS_UpdatesAssignment");

                // Populate new deployment properties.
                // Note: newTemplateName must be unique.

                newSUMUpdatesAssignment["ApplyToSubTargets"].BooleanValue = newApplyToSubTargets;
                newSUMUpdatesAssignment["AssignedCIs"].IntegerArrayValue = newArrayAssignedCIs;
                newSUMUpdatesAssignment["AssignmentAction"].IntegerValue = newAssignmentAction;
                newSUMUpdatesAssignment["AssignmentDescription"].StringValue = newAssignmentDescription;
                newSUMUpdatesAssignment["AssignmentName"].StringValue = newAssignmentName;
                newSUMUpdatesAssignment["DesiredConfigType"].IntegerValue = newDesiredConfigType;
                newSUMUpdatesAssignment["DPLocality"].IntegerValue = newDPLocality;
                newSUMUpdatesAssignment["LocaleID"].IntegerValue = newLocaleID;
                newSUMUpdatesAssignment["LogComplianceToWinEvent"].BooleanValue = newLogComplianceToWinEvent;
                newSUMUpdatesAssignment["NotifyUser"].BooleanValue = newNotifyUser;
                newSUMUpdatesAssignment["RaiseMomAlertsOnFailure"].BooleanValue = newRaiseMomAlertsOnFailure;
                newSUMUpdatesAssignment["NotifyUser"].BooleanValue = newNotifyUser;
                newSUMUpdatesAssignment["SendDetailedNonComplianceStatus"].BooleanValue = newSendDetailedNonComplianceStatus;
                newSUMUpdatesAssignment["StartTime"].StringValue = newStartTime;
                newSUMUpdatesAssignment["SuppressReboot"].IntegerValue = newSuppressReboot;
                newSUMUpdatesAssignment["TargetCollectionID"].StringValue = newTargetCollectionID;
                newSUMUpdatesAssignment["UseGMTTimes"].BooleanValue = newUseGMTTimes;

                // Save new deployment and new deployment properties.
                newSUMUpdatesAssignment.Put();

                // Output the new deployment name.
                Console.WriteLine("Created deployment: " + newAssignmentName);
            }

            catch (SmsException ex)
            {
                Console.WriteLine("Failed to create newSUMUpdatesAssignment. Error: " + ex.Message);
                throw;
            }
        }


        private string getCI(WqlConnectionManager connection, string SUG)
        {
            
            string updatesGroup = SUG;

            //Place all CIs from the group into an int[]
            string strScope = connection.NamedValueDictionary["Connection"].ToString();
            ManagementScope scope = new ManagementScope(strScope);
            WqlObjectQuery wqlQuery = new WqlObjectQuery(string.Format("SELECT ToCIID from SMS_CIRelation  WHERE FromCIID= {0} AND RelationType=1", updatesGroup)); // RelationshipType 1 is group relationship
            ManagementObjectSearcher searcher = new ManagementObjectSearcher(scope, wqlQuery);
            List<int> targettedCIs = new List<int>();

            string ret = "";
            foreach (ManagementObject CI in searcher.Get())
            {
                ret += CI.ToString();
                targettedCIs.Add(Int32.Parse(CI.GetPropertyValue("ToCIID").ToString(), System.Globalization.NumberFormatInfo.InvariantInfo));
            }

            return ret;

        }

        public WqlConnectionManager WMIConn()
        {
            string computer = cboSiteServer.Text;
            //            string userName = Environment.UserDomainName + "\\" + txtUser.Text;
            //            string password = txtPass.Text;

            // Make connection to provider.
            //            WqlConnectionManager WMIConnection = Connect(computer, userName, password);
            computer = cboSiteServer.Text;
            WqlConnectionManager WMIConnection = Connect(computer, Environment.UserDomainName + "\\sbondsa", textBox2.Text);
            return WMIConnection;
        }

        public WqlConnectionManager Connect(string serverName, string userName, string userPassword)
        {
            try
            {
                SmsNamedValuesDictionary namedValues = new SmsNamedValuesDictionary();
                WqlConnectionManager connection = new WqlConnectionManager(namedValues);

                if (System.Net.Dns.GetHostName().ToUpper() == serverName.ToUpper())
                {
                    // Connect to local computer.
                    connection.Connect(serverName);
                }
                else
                {
                    // Connect to remote computer.
                    connection.Connect(serverName, userName,userPassword);
                }

                return connection;
            }
            catch (SmsException e)
            {
                txtConnInfo.Text = "Failed to Connect. Error: " + e.Message;
                return null;
            }
            catch (UnauthorizedAccessException e)
            {
                txtConnInfo.Text = "Failed to authenticate. Error:" + e.Message;
                return null;
            }
        }

        private void chkMonthlyPatches_CheckedChanged(object sender, EventArgs e)
        {
            if (chkMonthlyPatches.Checked)
            {
                chkCollections.Enabled = false;
                chkMembership.Enabled = false;
            }

            if (chkMonthlyPatches.Checked == false)
            {
                chkCollections.Enabled = true;
                chkMembership.Enabled = true;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DateTime date = DateTime.Now;
            var shortDate = date.ToString("yyyyMMdd");
            txtPowershell.Text = shortDate;
        }

        private void cboSiteServer_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboSiteServer.Text == "UKWKMH-VMMA020") txtSiteCode.Text = "NPR";
            if (cboSiteServer.Text == "UKJHMH-VMMA008") txtSiteCode.Text = "WPR";
            if (cboSiteServer.Text == "MCJS-SCCM002A") txtSiteCode.Text = "WAC";
        }




        //private void btnSelectCopy_Click(object sender, EventArgs e)
        //{
        //    if (txtPowershell.SelectionLength == 0)
        //    {
        //        txtPowershell.SelectAll();
        //        txtPowershell.Copy();
        //    }
        //}


        //public Collection<PSObject> PSExec(string PS)
        //{
        //    Collection<PSObject> PSOutput;

        //    using (Runspace space = RunspaceFactory.CreateRunspace())
        //    {
        //        space.Open();

        //        using (PowerShell PowerShellInstance = PowerShell.Create())
        //        {
        //            PowerShellInstance.Runspace = space;
        //            PowerShellInstance.AddScript(PS);
        //            Pipeline pipe = space.CreatePipeline();
        //            pipe.Commands.Add(new Command("Set-ExecutionPolicy RemoteSigned -Scope Process", true));

        //            // invoke execution on the pipeline (collecting output)
        //            PSOutput = PowerShellInstance.Invoke();                    
        //        }

        //        space.Close();

        //        return PSOutput;


        //    }


        //}


        //        private void displayScript()
        //        {
        //            string exceptionGroup = "";
        //            string CMPSModule = @"D:\Program Files\Microsoft Configuration Manager\AdminConsole\bin\ConfigurationManager.psd1";

        //            if (Domain == "NETACPT")
        //                exceptionGroup = Domain + "\\\\WTR-SCCM NPD-Exception'";
        //            else
        //                exceptionGroup = Domain + "\\\\WTR-SCCM WPR-Exception'";

        //            if (!System.IO.File.Exists(CMPSModule))
        //            {
        //                MessageBox.Show("Unable to find ConfigMgr Powershell Module on site server. Have you opened this application with correct privileges?");
        //                return;
        //            }


        //            string deployUpdates = "deployUpdates " + (char)34 + @"$SUGName" + (char)34 + @" " + (char)34 + @"$DeploymentName" + (char)34 + @" " + (char)34 + @"$CollName" + (char)34 + @" " + (char)34 + @"$AvailableDay" + (char)34 + @" " + (char)34 + @"$EnforcementDeadLineDay" + (char)34 + @" " + (char)34 + @"$EnforcementDeadlineTime" + (char)34 + @"";
        //            string createCollection = "New-CMDeviceCollection -Name $CollName -LimitingCollectionName " + (char)34 + @"All Systems" + (char)34 + @" -RefreshSchedule $Schedule1 -RefreshType Both";

        //            string membershipRule = "Add-CMDeviceCollectionQueryMembershipRule -RuleName " + (char)34 + @"$ruleName" + (char)34 + @" -CollectionName " + (char)34 + @"$CollName" + (char)34 + @" -QueryExpression " + (char)34 + @"select SMS_R_SYSTEM.ResourceID,SMS_R_SYSTEM.ResourceType,SMS_R_SYSTEM.Name,SMS_R_SYSTEM.SMSUniqueIdentifier,SMS_R_SYSTEM.ResourceDomainORWorkgroup,SMS_R_SYSTEM.Client from SMS_R_System where SMS_R_System.SystemGroupName = " + (char)34 + (char)34 + @"$grp" +(char)34 + (char)34 + @" and SMS_R_System.Name not in (select distinct SMS_R_System.Name from  SMS_R_System where SMS_R_System.SystemGroupName = "+(char)34 + (char)34 + @"$ExceptionGroup"+(char)34 + (char)34 +")" + (char)34;

        //            txtPowershell.Text = membershipRule;



        //            if (chkMonthlyPatches.Checked == false) deployUpdates = "";
        //            if (chkMembership.Checked == false) membershipRule = "";
        //            if (chkCollections.Checked == false) createCollection = "";



        //            strPSScript = @"Import-Module '" + CMPSModule +  @"'
        //# Example SUG Deployment Name = 0715_BaseUpdates_WK1_Sun (20151018_0300)
        //CD " + txtSiteCode.Text + @": 
        //
        //Function deployUpdates($SUGName, $deploymentName, $collectionName, $AvailableDay, $EnforcementDeadLineDay, $EnforcementDeadlineTime)
        //    {
        //        " + (char)34 + @"Start-CMSoftwareUpdateDeployment -SoftwareUpdateGroupName $SUGName -CollectionName $collectionName -DeploymentName $deploymentName -DeploymentType Required -TimeBasedOn UTC -DeploymentAvailableDay $AvailableDay -DeploymentAvailableTime 00:00 -UserNotification DisplayAll -SoftwareInstallation $True -AllowRestart $True -RestartServer $True -RestartWorkstation $True -PersistOnWriteFilterDevice $True -GenerateSuccessAlert $False -DisableOperationsManagerAlert $True -GenerateOperationsManagerAlert $False -ProtectedType RemoteDistributionPoint -UnprotectedType UnprotectedDistributionPoint -UseBranchCache $False -DownloadFromMicrosoftUpdate $False" + (char)34 + @"
        //       
        //        Start-CMSoftwareUpdateDeployment -SoftwareUpdateGroupName " + (char)34 + @"$SUGName" + (char)34 + @" -CollectionName " + (char)34 + @"$collectionName" + (char)34 + @" -DeploymentName " + (char)34 + @"$deploymentName" + (char)34 + @" -DeploymentType Available -TimeBasedOn UTC -DeploymentAvailableDay $AvailableDay  -DeploymentAvailableTime 00:00 -UserNotification DisplayAll -SoftwareInstallation $True -AllowRestart $True -RestartServer $False -RestartWorkstation $False -PersistOnWriteFilterDevice $True -GenerateSuccessAlert $False -DisableOperationsManagerAlert $True -GenerateOperationsManagerAlert $False -ProtectedType RemoteDistributionPoint -UnprotectedType UnprotectedDistributionPoint -UseBranchCache $False -DownloadFromMicrosoftUpdate $False
        //        updateDeployUpdates " + (char)34 + @"$deploymentName" + (char)34 + @"       
        //    }
        //
        //    function updateDeployUpdates($deployUpdateGroupName)
        //    {
        //        " + (char)34 + @"Assign Deplyment Time for : " + (char)34 + @" + $deployUpdateGroupName
        //        $SiteCode = '" + txtSiteCode.Text + @"'
        //        $SiteServer = '" + txtSiteServer.Text + @"' 
        //        $ADRClientDeployment = Get-WmiObject -Namespace " + (char)34 + @"root\sms\site_$($SiteCode)" + (char)34 + @" -Class SMS_UpdateGroupAssignment -ComputerName $SiteServer
        //        foreach ($Deployment in $ADRClientDeployment)
        //            {
        //            if ($Deployment.AssignmentName -eq " + (char)34 + @"$deployUpdateGroupName" + (char)34 + @")
        //            {
        //            $DeploymentName = $Deployment.AssignmentName
        //            Write-Output " + (char)34 + @"Deployment to be modified: `n$($DeploymentName)" + (char)34 + @"
        //            try
        //                {
        //                $nameSplit = $DeploymentName.Split('(')
        //                $newDeadline = [Regex]::Replace($nameSplit[1].substring(0)," + (char)34 + @"[^0-9]" + (char)34 + @"," + (char)34 + @"" + (char)34 + @") + '00.000000+***'.TrimEnd()
        //                
        //                '$newDeadline = ' + $newDeadline
        //                
        //                $Deployment.EnforcementDeadline = " + (char)34 + @"$newDeadline" + (char)34 + @"
        //                $Deployment.RebootOutsideOfServiceWindows = $True
        //                $Deployment.OverrideServiceWindows = $True
        //                $Deployment.UseBranchCache = $True
        //                $Deployment.Put() | Out-Null
        //                if ($?) 
        //                {
       // //                   
        //                }
        //                }
        //            catch 
        //                {
        //                    Write-Output " + (char)34 + @"`nERROR: $($_.Exception.Message)" + (char)34 + @"
        //                }
        //                
        //                
        //            }
        //        }
        //        }
        //
        //
        //    function Get-PatchSunday
        //    {  
        //    <#   
        //        .SYNOPSIS    
        //        Get the Patch Tuesday of a month  
        //        .PARAMETER month  
        //        The month to check 
        //        .PARAMETER year  
        //        The year to check 
        //        .EXAMPLE   
        //        Get-PatchTue -month 6 -year 2015 
        //        .EXAMPLE   
        //        Get-PatchTue June 2015 
        //    #>  
        //  
        //    param(  
        //    [string]$month = (get-date).month,  
        //    [string]$year = (get-date).year 
        //    )  
        // 
        //    $firstdayofmonth = [datetime] ([string]$month + " + (char)34 + @"/1/" + (char)34 + @" + [string]$year) 
        //    (0..30 | % {$firstdayofmonth.adddays($_) } | ? {$_.dayofweek -like " + (char)34 + @"Sun*" + (char)34 + @"})[2] 
        //  
        //    }
        //
        //######################################################################################
        //
        //CLS
        //#$LogFile = " + (char)34 + @"D:\SoftwareUpdateLogs\" + (char)34 + @" + (Get-date -Format " + (char)34 + @"yyyyMM%d" + (char)34 + @") + " + (char)34 + @"_SoftwareUpdateDeployments.log" + (char)34 + @"
        //$ExceptionGroup = '" + exceptionGroup + @"
        //$Schedule1 = New-CMSchedule -Start " + (char)34 + @"01/01/2014 9:00 PM" + (char)34 + @" -DayOfWeek Monday -RecurCount 1 
        //$CollectionScript = Get-Content " + (char)34 + txtScriptPath.Text + (char)34 + @"
        //
        //foreach($collection in $CollectionScript)
        //{
        //    $arr = $collection.Split(',')
        //
        //    if($arr.Count -lt 3) 
        //    {
        //        Write-Host(" + (char)34 + @"Input file not complete. Ensure it contains Deployment Name, Deployment AD Group and Update Group." + (char)34 + @")
        //        EXit
        //    }
        //
        //    $grp = '" + Domain + @"\\' + $arr[1]
        //    $arrWK = $arr[0].Split(' ')
        //
        //    $arrDay = $grp.Split('-')   
        //    $patchSunday = Get-PatchSunday  
        //
        //    
        //    $day = $arrDay[2] #eg day 02
        //    $time = $arrDay[3] #eg 0300
        //    " + (char)34 + @"day = $day" + (char)34 + @"
        //    " + (char)34 + @"time =$time" + (char)34 + @"
        //    #Get Week
        //    $WK = $arrWK[3]
        //    " + (char)34 + @"WK = $WK" + (char)34 + @"
        //    $SUGName = $arr[2]
        //    " + (char)34 + @"SUGNAME = $SUGName" + (char)34 + @"
        //    $CollName = $arr[0]
        //    " + (char)34 + @"CollName = $CollName" + (char)34 + @"
        //    $ruleName = $CollName.Replace(" + (char)34 + @"Software Updates - " + (char)34 + @"," + (char)34 + @"" + (char)34 + @")
        //    " + (char)34 + @"ruleName = $ruleName" + (char)34 + @"  
        //    # Construct Deployment Name
        //    $AvailableDayShort = (get-date(get-date(Get-PatchSunday)).AddDays(13+$day)-UFormat " + (char)34 + @"%Y%m%d" + (char)34 + @")
        //    " + (char)34 + @"AvailableDayShort = $AvailableDayShort" + (char)34 + @"
        //    $AvailableDay = (get-date(get-date(Get-PatchSunday)).AddDays(13+$day)-UFormat " + (char)34 + @"%Y/%m/%d" + (char)34 + @")
        //    " + (char)34 + @"AvailableDay = $AvailableDay" + (char)34 + @"
        //
        //    $deploymentName = $SUGName + " + (char)34 + @"_" + (char)34 + @" + $WK + " + (char)34 + @"_" + (char)34 + @" + " + (char)34 + @"($AvailableDayShort" + (char)34 + @" + " + (char)34 + @"_" + (char)34 + @" + $time + " + (char)34 + @")" + (char)34 + @"
        //    " + (char)34 + @"deploymentName = $deploymentName" + (char)34 + @"
        //                
        //    " + createCollection + @"
        //    " + membershipRule + @"
        //    " + deployUpdates + @"
        //}";


        //            txtPowershell.Text = strPSScript;
        //        }
    }
    
}
