﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;

namespace SoftwareUpdateTool
{
    public partial class frmGroupTemplate : Form
    {
        public frmSUPTool m_parent;
        public frmGroupTemplate(frmSUPTool frm1)
        {
            InitializeComponent();
            m_parent = frm1;
        }


        private void btnApplyTemplate_Click(object sender, EventArgs e)
        {
            if (txtEnv1.Text == "" || txtSC1.Text == "" || txtStTime1.Text == "" || txtEndTime1.Text == "")
            {
                MessageBox.Show("Please ensure all boxes have been populated.", "Unpopulated Template", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            setRegValue("SITE", txtSC1.Text.ToUpper());
            setRegValue("ENVIRONMENT", txtEnv1.Text.ToUpper());
            setRegValue("ST1", txtStTime1.Text);
            setRegValue("ET1", txtEndTime1.Text);

            // set those below regardless so there are entries there for later, even if they don't contain anything.
            setRegValue("ST2", txtStTime2.Text);
            setRegValue("ET2", txtEndTime2.Text);
            setRegValue("ST3", txtStTime3.Text);
            setRegValue("ET3", txtEndTime3.Text);
            this.Close();
        }

        private void Line2Enabled()
        {
            txtSC2.Text = txtSC1.Text;
            txtEnv2.Text = txtEnv1.Text;
            txtStTime2.Enabled=true;
            txtEndTime2.Enabled=true;

           // txtSC2.BackColor = Color.White;
           // txtEnv2.BackColor = Color.White;
            txtStTime2.BackColor = Color.White;
            txtEndTime2.BackColor = Color.White;
        }

        private void Line3Enabled()
        {
            txtSC3.Text = txtSC1.Text;
            txtEnv3.Text = txtEnv1.Text;
            txtStTime3.Enabled = true;
            txtEndTime3.Enabled = true;

         //   txtSC3.BackColor = Color.White;
         //   txtEnv3.BackColor = Color.White;
            txtStTime3.BackColor = Color.White;
            txtEndTime3.BackColor = Color.White;
        }

        private void setRegValue(string name, string value)
        {
            RegistryKey regKey = Registry.CurrentUser.CreateSubKey("SOFTWARE\\Bondytech\\SoftwareUpdateTool");
            regKey.SetValue(name, value);
        }

        private void txtSC1_TextChanged(object sender, EventArgs e)
        {
            lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
            enableLine2(); enableLine3();
            

        }

        private void txtEnv1_TextChanged(object sender, EventArgs e)
        {
            lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
            enableLine2();
        }

        private void txtStTime1_TextChanged(object sender, EventArgs e)
        {
            lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
            enableLine2(); 
        }

        private void txtEndTime1_TextChanged(object sender, EventArgs e)
        {
            lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
            enableLine2(); 
        }

        private void enableLine2()
        {
            if (txtEnv1.Text != "" && txtSC1.Text != "" && txtStTime1.Text != "" && txtEndTime1.Text != "")
            {
                Line2Enabled();
            }
        }

        private void enableLine3()
        {
            if (txtStTime2.Text != "" && txtEndTime2.Text != "")
            {
                Line3Enabled();
            }
        }

        private void txtStTime2_TextChanged(object sender, EventArgs e)
        {
            enableLine3();
        }

        private void txtEndTime2_TextChanged(object sender, EventArgs e)
        {
            enableLine3();
        }

    }
}
