﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;
using System.Management.Automation;
using System.Drawing;
using Microsoft.ConfigurationManagement.ManagementProvider;
using Microsoft.ConfigurationManagement.ManagementProvider.WqlQueryEngine;
using System.IO;
using System.Management;
using System.Text.RegularExpressions;
using System.DirectoryServices.AccountManagement;
using System.Linq;
using System.Threading;
using System.DirectoryServices;
using Microsoft.Win32;

namespace SoftwareUpdateTool
{
    
    public partial class frmSUPTool : Form
    {
        public SynchronizationContext _syncContext = null;
        string Domain = Environment.UserDomainName;
        
        public frmSUPTool()
        {
            InitializeComponent();
            txtDomain.Text = DNFqdn();
            this.dataGridView1.DefaultCellStyle.ForeColor = Color.Black;
            this.groupBox1.ForeColor = Color.White;
            _syncContext = SynchronizationContext.Current;
            txtUser.Text = Environment.UserName;
        }



        private void btnCheckScript_Click(object sender, EventArgs e)
        {
            if(dataGridView1.Rows.Count !=0)

            if (lstSUGs.SelectedIndex == -1)
            {
                MessageBox.Show("Please select a Software Update Group first.","Software Update Group Not Selected",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
                return;
            }
            getADGroups(WMIConn());
            checkScript();
            dataGridView1.ClearSelection();
        }



        private void checkScript()
        {
            int i = 0;
            if (lstSUGs.Items.Count == 0)
            {
                MessageBox.Show("No software update groups selected.", "Select Software Update Group", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            string SUGname = lstSUGs.SelectedItem.ToString();
            foreach (string grp in lstADGroups.Items)
            {
                dataGridView1.Rows.Add();

                dataGridView1.Rows[i].Cells[1].Value = grp;
                dataGridView1.Rows[i].Cells[2].Value = SUGname;
                dataGridView1.Rows[i].Cells[0].Value = getCollectionName(grp);
                i++;
            }
                
        }

        private void getADGroups(WqlConnectionManager connection)
        {
            string strRegex = @"^[a-z]{3}-SCCM\s[a-z]{3}-[0-9]{2}-[0-9]{4}-[0-9]{4}$";
            
            // Instantiate the regular expression object.
            Regex r = new Regex(strRegex, RegexOptions.IgnoreCase);
            if (txtDomain.Text == "")
            {
                MessageBox.Show("Please enter FQDN in domain box.", "No domain", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            string FQDN = txtDomain.Text;
            string OU;

            try
            {
                if (txtOU.Text != "")
                    OU = txtOU.Text + "," + GetLocalhostFqdn();
                else
                    OU = GetLocalhostFqdn();

                PrincipalContext yourOU = new PrincipalContext(ContextType.Domain, FQDN, OU);

                GroupPrincipal findAllGroups = new GroupPrincipal(yourOU, "*");
                PrincipalSearcher ps = new PrincipalSearcher(findAllGroups);
                foreach (var group in ps.FindAll())
                {
                    Match m = r.Match(group.SamAccountName);
                    if (m.Success)
                    {
                        lstADGroups.Items.Add(group.SamAccountName);
                    }
                }
            }
            catch (Exception e)
            {
                warning();
                txtInfo.Text = e.Message;
                //Log(e.Message);
            }
            
        }
        public void warning()
        {
            txtInfo.ForeColor = Color.Red;
            txtInfo.BackColor = Color.Black;
        }
        public void green()
        {
            txtInfo.ForeColor = Color.LightGreen;
            txtInfo.BackColor = Color.Black;
        }

        private List<string> checkGrid()
        {
          //  int cell = -100; //unlikely
            List<string> lst = new List<string>();
            for(int j=0;j<dataGridView1.RowCount;j++)
                {
                    for (int k = 0; k < 3; k++)
                    {
                        if (dataGridView1.Rows[j].Cells[k].Selected)
                        {
                            lst.Add(dataGridView1.Rows[j].Cells[0].Value.ToString() + "," + dataGridView1.Rows[j].Cells[1].Value.ToString() + "," + dataGridView1.Rows[j].Cells[2].Value.ToString());
                        }
                    }
                }
            // Remove duplicates
            lst = lst.Distinct().ToList();
            return lst;
        }

        private void btnRunScript_Click(object sender, EventArgs e)
        {



            if (chkMonthlyPatches.Checked)
            {
                if (dataGridView1.Rows.Count == 0)
                {
                    MessageBox.Show("No schedule displayed. Run 'Get Schedule' first.", "Deploy", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                List<string> lst = new List<string>();
                lst = checkGrid();

                if (lst.Count == 0)
                {
                    var ques = MessageBox.Show("No updates selected in schedule. Do you wish to deploy all updates in the schedule?", "Deploy Updates", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (ques == DialogResult.No) return;
                    dataGridView1.SelectAll();

                }


                if (configureUpdates())
                    MessageBox.Show("Updates Deployed Successfully.", "Update Status", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    MessageBox.Show("Updates Unsuccessful.", "Update Status", MessageBoxButtons.OK, MessageBoxIcon.Warning);

                progressBar1.Value = 0; progressBar1.Refresh();
            }


        }

        private bool configureUpdates()
        {
            // See https://msdn.microsoft.com/en-us/library/hh949014.aspx

            if (txtUser.Text == "" || txtPassword.Text == "")
            {
                MessageBox.Show("Please enter username and password in appropriate box.");
                return false;
            }
            string strColl = "";
            string strADGrp = "";
            string strSUG = "";
            string strQuery = "";
            string strQueryName = "";
            string strExceptionGroup = "";
            string strAssignmentName;
            int DesiredConfigType = 1;  // 1 (0x1)
            int DPLocality = 64; // 80 (0x50)
            int newLocaleId = 1033; // 1033 (0x409)
            bool newLogComplianceToWinEvent = false; //FALSE
            bool notifyUser = true; //TRUE
            bool raiseMOMAlertsOnFailure = false; //FALSE
            bool sendDetailedNonComplianceStatus = false; //FALSE
            int newSuppressReboot = 0; //0 (0x0)
            bool configureUpdates = false;
            bool newORServiceWindows = true;
            bool WoL = true;
            bool newRebootServiceWindows = true;
            int assignmentType = 5;
            string newCollectionID;

            WqlConnectionManager conn = WMIConn();

            if (Environment.UserDomainName == "NETACPT")
                strExceptionGroup = @"NETACPT\\WTR-SCCM NPD-Exception";
            else
                strExceptionGroup = @"NETDOM\\WTR-SCCM WPR-Exception";

            lblExceptionGrp.Text = "Exception Group : " + strExceptionGroup;

            List<string> lst = new List<string>();
            lst = checkGrid();
            if (lst.Count > 0) // remove existing rows
            {
                dataGridView1.Rows.Clear();
                dataGridView1.DataSource = null;
                dataGridView1.Refresh();

            }

            for (int i = 0; i < lst.Count; i++) 
            {
                string[] arrEntry = lst.ElementAt(i).Split(',');
                dataGridView1.Rows.Add();
                dataGridView1.Rows[i].Cells[0].Value = arrEntry[0];
                dataGridView1.Rows[i].Cells[1].Value = arrEntry[1];
                dataGridView1.Rows[i].Cells[2].Value = arrEntry[2];
                
            }
            
            var ques = MessageBox.Show("You have selected to deploy to the schedule below. Is this what you want?", "Deploy Updates", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (ques == DialogResult.Cancel) return false;

            int UpdateCount = dataGridView1.RowCount;
            progressBar1.Maximum = UpdateCount;

            for (int i = 0; i < UpdateCount; i++)
                {
                    string collectionName = dataGridView1.Rows[i].Cells[0].Value.ToString();
                    strADGrp = dataGridView1.Rows[i].Cells[1].Value.ToString();
                    // string collection = getCollectionName(strADGrp).Replace("Software Updates - ", "");
                    // dataGridView1.Rows[i].Cells[0].Value = getCollectionName(strADGrp);
                    newCollectionID = GetCollectionID(conn, collectionName);

                    int[] SUGIDs = getSoftwareUpdateGroupsFromCollection(conn, newCollectionID);
                    strSUG = dataGridView1.Rows[i].Cells[2].Value.ToString();
                    strAssignmentName = getAssignmentName(strSUG, strADGrp);
                    string enforcementDeadline = getTime(strAssignmentName, true);
                    string startTime = getTime(strAssignmentName, false);
                    int[] CI_ID = getUpdatesFromUpdateGroup(conn, getCI(conn, strSUG));
                    Int32 AssignedUpdateGroup = getCI(conn, strSUG);
                    bool createAssignment = false;
                    bool createCollections = false;
                    bool createMembershipRules = false;
                    if (chkMonthlyPatches.Checked) createAssignment = true;
                    if (chkMembership.Checked) createMembershipRules = true;
                    if (chkCollections.Checked) createCollections = true;
                   
                    if (createAssignment)
                    {
                        // Check that Software Update Group isn't already assigned to the collection
                        foreach (int SUGID in SUGIDs)
                        {
                            if (AssignedUpdateGroup == SUGID)
                            {
                                warning();
                                txtInfo.Text = collectionName + " already has " + strAssignmentName + " assigned.";
                                Log(collectionName + " already has " + strAssignmentName + " assigned.");
                                createAssignment = false;
                            }
                        }
                    }

                    // Create Collection if option is checked
                    if (createCollections)
                    {
                        strQuery = "select SMS_R_SYSTEM.ResourceID,SMS_R_SYSTEM.ResourceType,SMS_R_SYSTEM.Name,SMS_R_SYSTEM.SMSUniqueIdentifier,SMS_R_SYSTEM.ResourceDomainORWorkgroup,SMS_R_SYSTEM.Client from SMS_R_System where SMS_R_System.SystemGroupName = '" + strADGrp + "' and SMS_R_System.Name not in (select distinct SMS_R_System.Name from  SMS_R_System where SMS_R_System.SystemGroupName = '" + strExceptionGroup + "')";
                        CreateDynamicCollection(conn, strColl, "", true, strQuery, strQueryName, "SMS00001", createAssignment, createCollections, createMembershipRules);
                    }

                    progressBar1.Value = i+1;

                    if (createAssignment) // Deploy Updates
                    {
                        configureUpdates = ConfigureAndDeploySUMUpdates(conn, true, CI_ID, AssignedUpdateGroup, 2, strSUG, strAssignmentName, DesiredConfigType, DPLocality, newLocaleId, newLogComplianceToWinEvent, notifyUser, raiseMOMAlertsOnFailure, sendDetailedNonComplianceStatus, startTime, enforcementDeadline, newSuppressReboot, newCollectionID, true, newORServiceWindows, WoL, newRebootServiceWindows, assignmentType);

                        // Indicate if update successful by changing row colour
                        if (configureUpdates)
                            dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.LightGreen;
                        else
                            dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.Red;
                    }
                }

            return configureUpdates;
        }


        public bool ConfigureAndDeploySUMUpdates(WqlConnectionManager connection,

                                               bool newApplyToSubTargets,
                                               int[] newArrayAssignedCIs,
                                               int AssignedUpdateGroup,
                                               int newAssignmentAction, // 1 = Detect, 2 = Apply
                                               string newAssignmentDescription,
                                               string newAssignmentName,
                                               int newDesiredConfigType, // 1 = required, 2 = not_allowed
                                               int newDPLocality, // DP_DOWNLOAD_FROM_LOCAL
                                               int newLocaleID,
                                               bool newLogComplianceToWinEvent,
                                               bool newNotifyUser,
                                               bool newRaiseMomAlertsOnFailure,
                                               bool newSendDetailedNonComplianceStatus,
                                               string newStartTime,
                                               string enforcementDeadline,
                                               int newSuppressReboot,
                                               string newTargetCollectionID,
                                               bool newUseGMTTimes,
                                               bool newORServiceWindows,
                                               bool WoL,
                                               bool newRebootServiceWindows,
                                               int assignmentType
                   )
        {
            try
            {
                // Create the deployment object.
                IResultObject newSUMUpdatesAssignment = connection.CreateInstance("SMS_UpdateGroupAssignment");

                // Populate new deployment properties.
                // Note: newTemplateName must be unique.

                newSUMUpdatesAssignment["ApplyToSubTargets"].BooleanValue = newApplyToSubTargets;
                newSUMUpdatesAssignment["AssignedCIs"].IntegerArrayValue = newArrayAssignedCIs;
                newSUMUpdatesAssignment["AssignedUpdateGroup"].IntegerValue = AssignedUpdateGroup;
                newSUMUpdatesAssignment["AssignmentAction"].IntegerValue = newAssignmentAction;
                newSUMUpdatesAssignment["AssignmentDescription"].StringValue = newAssignmentDescription;
                newSUMUpdatesAssignment["AssignmentName"].StringValue = newAssignmentName;
                newSUMUpdatesAssignment["DesiredConfigType"].IntegerValue = newDesiredConfigType;
                newSUMUpdatesAssignment["DPLocality"].IntegerValue = newDPLocality;
                newSUMUpdatesAssignment["LocaleID"].IntegerValue = newLocaleID;
                newSUMUpdatesAssignment["LogComplianceToWinEvent"].BooleanValue = newLogComplianceToWinEvent;
                newSUMUpdatesAssignment["NotifyUser"].BooleanValue = newNotifyUser;
                newSUMUpdatesAssignment["RaiseMomAlertsOnFailure"].BooleanValue = newRaiseMomAlertsOnFailure;
                newSUMUpdatesAssignment["NotifyUser"].BooleanValue = newNotifyUser;
                newSUMUpdatesAssignment["SendDetailedNonComplianceStatus"].BooleanValue = newSendDetailedNonComplianceStatus;
                newSUMUpdatesAssignment["StartTime"].StringValue = newStartTime;
                newSUMUpdatesAssignment["EnforcementDeadline"].StringValue = enforcementDeadline;
                newSUMUpdatesAssignment["SuppressReboot"].IntegerValue = newSuppressReboot;
                newSUMUpdatesAssignment["TargetCollectionID"].StringValue = newTargetCollectionID;
                newSUMUpdatesAssignment["UseGMTTimes"].BooleanValue = newUseGMTTimes;
                newSUMUpdatesAssignment["RebootOutsideOfServiceWindows"].BooleanValue = newRebootServiceWindows;
                newSUMUpdatesAssignment["OverrideServiceWindows"].BooleanValue = newORServiceWindows;
                newSUMUpdatesAssignment["WoLEnabled"].BooleanValue = WoL;
                newSUMUpdatesAssignment["assignmentType"].IntegerValue = assignmentType;
                newSUMUpdatesAssignment["PersistOnWriteFilterDevices"].BooleanValue = true;
                newSUMUpdatesAssignment["LimitStateMessageVerbosity"].BooleanValue = true;
                newSUMUpdatesAssignment["DisableMomAlerts"].BooleanValue = true;
                newSUMUpdatesAssignment["StateMessageVerbosity"].IntegerValue = 5;

                // Save new deployment and new deployment properties.
                newSUMUpdatesAssignment.Put();

                // Output the new deployment name.
                green();
                txtInfo.Text = "Created deployment: " + newAssignmentName;
                Log("Created deployment: " + newAssignmentName);
                return true;
            }

            catch (SmsException ex)
            {
                warning();
                txtInfo.Text = "Failed to create newSUMUpdatesAssignment. Error: " + ex.Message;
                Log("Failed to create newSUMUpdatesAssignment. Error: " + ex.Message);
                return false;
                throw;
            }
        }


        public int[] getSoftwareUpdateGroupsFromCollection(WqlConnectionManager connection, string CollectionID)
        {
            // SELECT AssignedUpdateGroup FROM SMS_UpdateGroupAssignment where TargetCollectionID='npr000bb'
            try
            {
                string Query1 = "SELECT AssignedUpdateGroup FROM SMS_UpdateGroupAssignment where TargetCollectionID='" + CollectionID + "'";
                List<int> upd = new List<int>();
                IResultObject SUGAssignment = connection.QueryProcessor.ExecuteQuery(Query1);

                foreach (IResultObject AssignmentID in SUGAssignment)
                {
                    Dictionary<string, string> dictionary = new Dictionary<string, string>();
                    dictionary = AssignmentID.PropertyList;
                    string AssID;
                    dictionary.TryGetValue("AssignedUpdateGroup", out AssID);

                    upd.Add(Convert.ToInt32(AssID));

                }

                Int32[] arrUpdateGroups = upd.ToArray();

                return arrUpdateGroups;
            }
            catch (Exception e)
            {
                warning();
                txtInfo.Text = e.Message;
                Log(e.Message);
                return null;
            }
        }

        public int[] getUpdatesFromUpdateGroup(WqlConnectionManager connection, int SUGID)
        {
            try
            {
                string Query1 = "SELECT upd.* FROM SMS_SoftwareUpdate upd, SMS_CIRelation cr WHERE cr.FromCIID=" + SUGID + " AND cr.RelationType=1 AND upd.CI_ID=cr.ToCIID";
                List<int> upd = new List<int>();
                IResultObject ListOfUpdates = connection.QueryProcessor.ExecuteQuery(Query1);

                foreach (IResultObject update in ListOfUpdates)
                {
                    Dictionary<string, string> dictionary = new Dictionary<string, string>();
                    dictionary = update.PropertyList;
                    string CIID;
                    dictionary.TryGetValue("CI_ID", out CIID);

                    upd.Add(Convert.ToInt32(CIID));
                }

                Int32[] arrUpdates = upd.ToArray();
                return arrUpdates;
            }
            catch (SmsException ex)
            {
                warning();
                txtInfo.Text = "Failed to list the packages and programs. Error: " + ex.Message;
                Log("Failed to list the packages and programs. Error: " + ex.Message);
                throw;
            }
        }


        private string getTime(string strAssignmentName, bool enforced)
        {
            // eg 15/11/2015 00:00:00
            // eg "1015_MSUpdates_WK2_Friday (20151127_2300)"
            // return eg 20150923110200.000000+***

            string[] splAssignmentName = strAssignmentName.Split(' ');
            string[] spldatetime = splAssignmentName[1].Split('_');
            string startDate = spldatetime[0].TrimStart('(');
            string startTime = spldatetime[1].TrimEnd(')');

            startDate = startDate.Insert(4, "/");
            startDate = startDate.Insert(7, "/");
            DateTime stdt = Convert.ToDateTime(startDate);
            string newdt = stdt.ToShortDateString();

            if (enforced == true)
                startTime = startTime.Insert(2, ":");
            else
                startTime = "00:00:00";


            DateTime stDate = Convert.ToDateTime(newdt + " " + startTime).AddHours(1); // for some reason you have to add an hour, no idea why

            string dmtfDateTime = ManagementDateTimeConverter.ToDmtfDateTime(stDate);
            return dmtfDateTime;
        }



        public void CreateDynamicCollection(WqlConnectionManager connection, string newCollectionName, string newCollectionComment, bool ownedByThisSite, string query, string ruleName, string LimitToCollectionID, bool PatchesOnly, bool CreateCollections, bool CreateQueries)
        {
            
            try
            {
                // Create new SMS_Collection object.
                IResultObject newCollection = connection.CreateInstance("SMS_Collection");

                // Populate the new collection object properties.
                newCollection["Name"].StringValue = newCollectionName;
                newCollection["Comment"].StringValue = newCollectionComment;
                newCollection["OwnedByThisSite"].BooleanValue = ownedByThisSite;
                newCollection["LimitToCollectionID"].StringValue = LimitToCollectionID;

                // Save the new collection object and properties.
                // In this case, it seems necessary to 'get' the object again to access the properties.
                if (CreateCollections) newCollection.Put();
                newCollection.Get();

                // Validate the query.
                Dictionary<string, object> validateQueryParameters = new Dictionary<string, object>();
                validateQueryParameters.Add("WQLQuery", query);
                IResultObject result = connection.ExecuteMethod("SMS_CollectionRuleQuery", "ValidateQuery", validateQueryParameters);

                // Create query rule.
                IResultObject newQueryRule = connection.CreateInstance("SMS_CollectionRuleQuery");
                newQueryRule["QueryExpression"].StringValue = query;
                newQueryRule["RuleName"].StringValue = ruleName;

                // Add the rule. Although not used in this sample, QueryID contains the query identifier.
                Dictionary<string, object> addMembershipRuleParameters = new Dictionary<string, object>();
                addMembershipRuleParameters.Add("collectionRule", newQueryRule);
                IResultObject queryID = newCollection.ExecuteMethod("AddMembershipRule", addMembershipRuleParameters);

                // Start collection evaluator.
                newCollection.ExecuteMethod("RequestRefresh", null);
                green();
                txtInfo.Text = "Created collection: " + newCollectionName;
                Log("Created collection: " + newCollectionName);
            }
            catch (SmsException ex)
            {
                warning();
                txtInfo.Text = "Failed to create collection. Error: " + ex.Message;
                Log("Failed to create collection. Error: " + ex.Message);
                throw;
            }
        }


        private string getAssignmentName(string SUG, string ADGrp)
        {
            string collection = getCollectionName(ADGrp).Replace("Software Updates - ","");
            collection =  collection.Replace(" ","");
            string[] splName = collection.Split('-');
            string pDay = patchDay(ADGrp);
            string assignmentName = SUG + "_" + splName[0] + "_" + splName[1] + " (" + pDay + "_" + splName[2] + ")";
            return assignmentName;
        }


        private string GetCollectionID(WqlConnectionManager connection,string CollectionName)
        {
            try
            {
                string Query1 = "SELECT * FROM SMS_Collection WHERE Name = '" + CollectionName + "'";
                string result = "";

                IResultObject ListOfResources1 = connection.QueryProcessor.ExecuteQuery(Query1);

                foreach (IResultObject Resource1 in ListOfResources1)
                {
                    result = Resource1["CollectionID"].StringValue;
                }

                return result;
            }
            catch (SmsException ex)
            {
                warning();
                txtInfo.Text = "Failed to list the packages and programs. Error: " + ex.Message;
                Log("Failed to list the packages and programs. Error: " + ex.Message);
                throw;
            }
        }

        private void getSUGs(WqlConnectionManager connection)
        {
            string strScope = connection.NamedValueDictionary["Connection"].ToString();
            ManagementScope scope = new ManagementScope(strScope);
            WqlObjectQuery wqlQuery = new WqlObjectQuery(string.Format("select * from SMS_AuthorizationList"));
            ManagementObjectSearcher searcher = new ManagementObjectSearcher(scope, wqlQuery);
            List<string> upd = new List<string>();
            
            foreach (ManagementObject CI in searcher.Get())
            {
                lstSUGs.Items.Add(CI.GetPropertyValue("LocalizedDisplayName"));
            }

        }

        private int getCI(WqlConnectionManager connection, string SUG)
        {
            
            string updatesGroup = SUG;
            string strScope = connection.NamedValueDictionary["Connection"].ToString();
            ManagementScope scope = new ManagementScope(strScope);
            WqlObjectQuery wqlQuery = new WqlObjectQuery(string.Format("select CI_ID from SMS_AuthorizationList Where LocalizedDisplayName = '{0}'", updatesGroup));
            ManagementObjectSearcher searcher = new ManagementObjectSearcher(scope, wqlQuery);
            
            string ret = "";
            foreach (ManagementObject CI in searcher.Get())
            {
                ret += CI.ToString();
            }

            string[] retspl = ret.Split('=');
            return Convert.ToInt32(retspl[1]);

        }

        public WqlConnectionManager WMIConn()
        {         
            string computer = cboSiteServer.Text;
            computer = cboSiteServer.Text;
            WqlConnectionManager WMIConnection = Connect(computer, Environment.UserDomainName + "\\" + txtUser.Text, txtPassword.Text);
            return WMIConnection;
        }

        public WqlConnectionManager Connect(string serverName, string userName, string userPassword)
        {
            try
            {
                SmsNamedValuesDictionary namedValues = new SmsNamedValuesDictionary();
                WqlConnectionManager connection = new WqlConnectionManager(namedValues);

                if (System.Net.Dns.GetHostName().ToUpper() == serverName.ToUpper())
                {
                    // Connect to local computer.
                    connection.Connect(serverName);
                }
                else
                {
                    // Connect to remote computer.
                    connection.Connect(serverName, userName,userPassword);
                }

                txtConnInfo.ForeColor = Color.LightGreen;
                txtConnInfo.Text = "Connected successfully to " + serverName;
                return connection;
            }
            catch (SmsException e)
            {
                
                txtConnInfo.ForeColor = Color.Red;
                txtConnInfo.Text = "Failed to Connect. Error: " + e.Message;
                return null;
            }
            catch (UnauthorizedAccessException e)
            {
                warning();
                txtConnInfo.Text = "Failed to authenticate. Error:" + e.Message;
                return null;
            }
        }

        private void chkMonthlyPatches_CheckedChanged(object sender, EventArgs e)
        {
            if (chkMonthlyPatches.Checked)
            {
                groupBox1.Enabled = false;

            }

            if (chkMonthlyPatches.Checked == false)
            {
                groupBox1.Enabled = true;

            }
        }




        private void cboSiteServer_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboSiteServer.Text == "UKWKMH-VMMA020") txtSiteCode.Text = "NPR";
            if (cboSiteServer.Text == "UKJHMH-VMMA008") txtSiteCode.Text = "WPR";
            if (cboSiteServer.Text == "MCJS-SCCM002A") txtSiteCode.Text = "WAC";
        }

        private string patchSunday() // First Sunday after patch Tuesday
        {
            DateTime date = DateTime.Now;
            int yr = date.Year;
            int mo = date.Month;
            string strPatchSunday = "";
            DateTime _date = new DateTime(yr, mo, 1);
            DayOfWeek day = _date.DayOfWeek;
            int d = 0;
            if (day == DayOfWeek.Wednesday) d += 7;
            var diff = DayOfWeek.Tuesday - day;
            DateTime secTuesday = _date.AddDays(diff + 7 + d);
            strPatchSunday = secTuesday.AddDays(5).ToString("yyyyMMd");

            return strPatchSunday;
        }

        private string patchDay(string ADGrp)
        {
            string pSunday = patchSunday().Insert(4, "/");
            pSunday = pSunday.Insert(7, "/");
            string[] splGrp = ADGrp.Split('-');
            int pDay = Convert.ToInt32(splGrp[2]);
         
            DateTime dt = Convert.ToDateTime(pSunday);
            if (ADGrp.Contains("NPD")) dt.AddDays(pDay);
            if (ADGrp.Contains("PRD")) dt.AddDays(14 + pDay);
            DateTime newDate = dt.AddDays(pDay-1);
           
            return newDate.ToString("yyyyMMdd");
        }

        private string getCollectionName(string ADGrp)
        {
            string[] splGrp = ADGrp.Split('-');
            int pDay = Convert.ToInt32(splGrp[2]);
            string pSunday = patchSunday().Insert(4, "/");
            pSunday = pSunday.Insert(7, "/");
            DateTime dt = Convert.ToDateTime(pSunday);

            //Get Collection Name From Group
            //If production then has to be WK3 or WK4
            string strStart = "Software Updates - ";
            string timeRange = splGrp[3] + "-" + splGrp[4];
            string wkDay = dt.AddDays(pDay-1).ToString("dddd");
            string wk;
            if (ADGrp.Contains("NPD")) // Acceptancee
            {
                if (pDay <= 7)
                    wk = "WK1";
                else
                    wk = "WK2"; 
            }
            else // Production
            {
                if (pDay <= 7)
                    wk = "WK3";
                else
                    wk = "WK4";
            }

            string collectionName = strStart + wk + " - " + wkDay + " - " + timeRange; // eg 'Software Updates - WK3 - Sunday - 1900-2300'

            return collectionName;
        }



        private string DNFqdn()
        {
            var ipProperties = System.Net.NetworkInformation.IPGlobalProperties.GetIPGlobalProperties();
            return ipProperties.DomainName.ToString();
        }

        private string GetLocalhostFqdn()
        {
            var ipProperties = System.Net.NetworkInformation.IPGlobalProperties.GetIPGlobalProperties();
            string fqdn = ipProperties.DomainName.ToString();
            string[] spl = fqdn.Split('.');
            string dc = ",DC=";
            for (int i = 0; i < spl.Length; i++ )
            {
                fqdn += dc +spl[i];
            }

            fqdn = fqdn.Replace(txtDomain.Text, "").TrimStart(',') ;

         //   fqdn = "DC=" + spl[0] + ",DC=" + spl[1] + ",DC=" + spl[2] + ",DC=" + spl[3];
            return fqdn;
        }

        private void btnFindGroups_Click(object sender, EventArgs e)
        {
            btnFindGroups.Text = "Searching...";
            getADGroups(WMIConn());
            btnFindGroups.Text = "Find Maintenance Window Groups";
        }

        private void btnFindSUGs_Click(object sender, EventArgs e)
        {
            btnFindSUGs.Text = "Searching...";
            getSUGs(WMIConn());
            btnFindSUGs.Text = "Find Software Update Groups";
        }


        private void Log(string text)
        {
            DateTime date = DateTime.Now;
            var shortDate = date.ToString("yyMMdd");

            using (StreamWriter writer = new StreamWriter("C:\\Temp\\" + shortDate + "_SoftwareUpdateTool.log", true))
            {
                writer.WriteLine(text + "\n\n");
            }

        }

        private void btnOpenLogFile_Click(object sender, EventArgs e)
        {

            string textLine="";
            DateTime date = DateTime.Now;
            var shortDate = date.ToString("yyMMdd");
            // Read the file and display it line by line.
            if (File.Exists("C:\\Temp\\" + shortDate + "_SoftwareUpdateTool.log"))
            {
                StreamReader objReader = new StreamReader("C:\\Temp\\" + shortDate + "_SoftwareUpdateTool.log");
                do
                {

                    textLine += objReader.ReadLine() + "\r\n";
                    lstADGroups.Items.Add(textLine);

                } while (objReader.Peek() != -1);

            }
            else
                return;

        }




        private string DetermineHoveredItem()
        {
            Point screenPosition = ListBox.MousePosition;
            Point listBoxClientAreaPosition = lstADGroups.PointToClient(screenPosition);

            int hoveredIndex = lstADGroups.IndexFromPoint(listBoxClientAreaPosition);
            if (hoveredIndex != -1)
                return lstADGroups.Items[hoveredIndex] as string;
            else
                return null;
        }

        private void btnCreateADGroups_Click(object sender, EventArgs e)
        {
            frmGroupTemplate ft = new frmGroupTemplate(this);
            ft.StartPosition = FormStartPosition.CenterParent;
            ft.ShowDialog(this);

            Dictionary<string, string> templateValues = getRegValues();
            String value;
            bool valST2 = false;
            bool valST3 = false;
            if (templateValues.TryGetValue("ST2", out value)) valST2 = true;
            if (templateValues.TryGetValue("ST3", out value)) valST3 = true;



            for (int j = 1; j < 15; j++) // Day loop
            {
                string t;
                string newCollectionName = "";

                // double digits
                if (j < 10)
                    t = "0" + j.ToString();
                else
                    t = j.ToString();

                newCollectionName = templateValues["SITE"] + "-SCCM " + templateValues["ENVIRONMENT"] + "-" + t + "-" + templateValues["ST1"] + "-" + templateValues["ET1"];
                try
                {
                    if (CreateGroup(txtOU.Text + "," + GetLocalhostFqdn(), newCollectionName))
                    {
                        green();
                        txtInfo.Text = newCollectionName + " Created.\r\n";
                        txtInfo.Refresh();
                        Log(newCollectionName + " Created.");
                    }
                }
                catch (Exception ex)
                {
                    warning();
                    txtInfo.Text = newCollectionName + " failed. \r\n" + ex.Message;
                    txtInfo.Refresh();
                    Log(newCollectionName + ": " + ex.Message);
                }


                if (valST2)
                {
                    newCollectionName = templateValues["SITE"] + "-SCCM " + templateValues["ENVIRONMENT"] + "-" + t + "-" + templateValues["ST2"] + "-" + templateValues["ET2"];
                    try
                    {
                        if (CreateGroup(txtOU.Text + "," + GetLocalhostFqdn(), newCollectionName))
                        {
                            green();
                            txtInfo.Text = newCollectionName + " Created.\r\n";
                            txtInfo.Refresh();
                            Log(newCollectionName + " Created.");
                        }
                    }
                    catch (Exception ex)
                    {
                        warning();
                        txtInfo.Text = newCollectionName + " failed. \r\n" + ex.Message;
                        txtInfo.Refresh();
                        Log(newCollectionName + ": " + ex.Message);
                    }
                }


                if (valST3)
                {
                    newCollectionName = templateValues["SITE"] + "-SCCM " + templateValues["ENVIRONMENT"] + "-" + t + "-" + templateValues["ST3"] + "-" + templateValues["ET3"];
                    try
                    {
                        if (CreateGroup(txtOU.Text + "," + GetLocalhostFqdn(), newCollectionName))
                        {
                            green();
                            txtInfo.Text = newCollectionName + " Created.\r\n";
                            txtInfo.Refresh();
                            Log(newCollectionName + " Created.\r\n");
                        }
                    }
                    catch (Exception ex)
                    {
                        warning();
                        txtInfo.Text = newCollectionName + " failed. " + ex.Message;
                        Log(newCollectionName + ": " + ex.Message);
                    }
                }
                progressBar1.Value += 1;
            }
        }

        private Dictionary<string,string> getRegValues()
        {
            string key = @"HKEY_CURRENT_USER\Software\Bondytech\SoftwareUpdateTool";
            string SITE = Registry.GetValue(key,"SITE",null).ToString();
            string ENVIRONMENT = Registry.GetValue(key,"ENVIRONMENT",null).ToString();
            string ST1  = Registry.GetValue(key,"ST1",null).ToString();
            string ET1  = Registry.GetValue(key,"ET1",null).ToString();
            string ST2  = Registry.GetValue(key,"ST2",null).ToString();
            string ET2  = Registry.GetValue(key,"ET2",null).ToString();
            string ST3  = Registry.GetValue(key,"ST3",null).ToString();
            string ET3  = Registry.GetValue(key,"ET3",null).ToString();

            Dictionary<string,string> regVals = new Dictionary<string,string>();
            regVals.Add("SITE",SITE);
            regVals.Add("ENVIRONMENT", ENVIRONMENT);
            regVals.Add("ST1", ST1);
            regVals.Add("ET1", ET1);
            regVals.Add("ST2", ST2);
            regVals.Add("ET2", ET2);
            regVals.Add("ST3", ST3);
            regVals.Add("ET3", ET3);

            return regVals;
        }

        public bool CreateGroup(string ouPath, string name)
        {
            if (txtOU.Text == "")
            {
                MessageBox.Show("Please populate OU field, eg 'OU=SCCM Groups'");
                return false;
            }
            ouPath = ouPath.TrimStart(',');
            if (!DirectoryEntry.Exists("LDAP://CN=" + name + "," + ouPath))
            {
                try
                {
                    string strDomain = txtDomain.Text;
                    string strUser = txtUser.Text;
                    string strPassword = txtPassword.Text;

                    // bind to the container, e.g. LDAP://cn=Users,dc=...
                    DirectoryEntry entry = new DirectoryEntry(@"LDAP://" + ouPath, strUser,strPassword,AuthenticationTypes.None);

                    // create group entry
                    DirectoryEntry group = entry.Children.Add("CN=" + name, "group");

                    // set properties
                    group.Properties["sAmAccountName"].Value = name;

                    // save group
                    group.CommitChanges();
                    green();
                    txtInfo.Text = name + " created successfully.";
                    return true;
                }
                catch (Exception e)
                {
                    warning();
                    txtInfo.Text = e.Message.ToString();
                    return false;
                }
            }
            else 
            {
                warning();
                txtInfo.Text =  "Group already exists";
                return false;
            }
        }
    }
    
}
