﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Text.RegularExpressions;

namespace SoftwareUpdateTool
{
    public partial class frmGroupTemplate : Form
    {
        public frmSUPTool m_parent;
        public frmGroupTemplate(frmSUPTool frm1)
        {
            InitializeComponent();
            m_parent = frm1;
        }


        private void btnApplyTemplate_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
   
            if (txtEnv1.Text == "" || txtSC1.Text == "" || txtStTime1.Text == "" || txtEndTime1.Text == "" || txtException.Text == "")
            {
                MessageBox.Show("Please ensure all boxes have been populated.", "Unpopulated Template", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            setRegValue("SITE", txtSC1.Text.ToUpper());
            setRegValue("ENVIRONMENT", txtEnv1.Text.ToUpper());
            setRegValue("ST1", txtStTime1.Text);
            setRegValue("ET1", txtEndTime1.Text);

            // set those below regardless so there are entries there for later, even if they don't contain anything.
            setRegValue("ST2", txtStTime2.Text);
            setRegValue("ET2", txtEndTime2.Text);
            setRegValue("ST3", txtStTime3.Text);
            setRegValue("ET3", txtEndTime3.Text);
            setRegValue("EXCEPTION", txtException.Text);
            setRegValue("NOREBOOT", lblNoReboot.Text);

            this.Close();
        }

        private void Line2Enabled()
        {
            txtSC2.Text = txtSC1.Text;
            txtEnv2.Text = txtEnv1.Text;
            txtStTime2.Enabled=true;
            txtEndTime2.Enabled=true;

            txtStTime2.BackColor = Color.White;
            txtEndTime2.BackColor = Color.White;
        }

        private void Line3Enabled()
        {
            txtSC3.Text = txtSC1.Text;
            txtEnv3.Text = txtEnv1.Text;
            txtStTime3.Enabled = true;
            txtEndTime3.Enabled = true;

            txtStTime3.BackColor = Color.White;
            txtEndTime3.BackColor = Color.White;
        }

        private void Line2Disabled()
        {
            txtSC2.Text = "";
            txtEnv2.Text = "";
            txtStTime2.Text = "";
            txtEndTime2.Text = "";
            txtStTime2.Enabled = false;
            txtEndTime2.Enabled = false;
            txtStTime2.BackColor = Color.WhiteSmoke;
            txtEndTime2.BackColor = Color.WhiteSmoke;
        }

        private void Line3Disabled()
        {
            txtSC3.Text = "";
            txtEnv3.Text = "";
            txtStTime3.Text = "";
            txtEndTime3.Text = "";
            txtStTime3.Enabled = false;
            txtEndTime3.Enabled = false;
            txtStTime3.BackColor = Color.WhiteSmoke;
            txtEndTime3.BackColor = Color.WhiteSmoke;
        }



        private void setRegValue(string name, string value)
        {
            RegistryKey regKey = Registry.CurrentUser.CreateSubKey("SOFTWARE\\Bondytech\\SoftwareUpdateTool");
            regKey.SetValue(name, value);
        }


        private void txtSC1_TextChanged(object sender, EventArgs e)
        {
            lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
            enableLine2(); enableLine3();
            

        }

        private void txtEnv1_TextChanged(object sender, EventArgs e)
        {

        }

        private void txtStTime1_TextChanged(object sender, EventArgs e)
        {
            lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
            enableLine2(); 
        }

        private void txtEndTime1_TextChanged(object sender, EventArgs e)
        {
            lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
            enableLine2(); 
        }

        private void enableLine2()
        {
            if (txtEnv1.Text != "" && txtSC1.Text != "" && txtStTime1.Text != "" && txtEndTime1.Text != "")
            {
                Line2Enabled();
            }
        }

        private void enableLine3()
        {
            if (txtStTime2.Text != "" && txtEndTime2.Text != "")
            {
                Line3Enabled();
            }
        }

        private void txtStTime2_TextChanged(object sender, EventArgs e)
        {
            enableLine3();
        }

        private void txtEndTime2_TextChanged(object sender, EventArgs e)
        {
            enableLine3();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            
            var ans = MessageBox.Show("Are you sure you wish to cancel without creating an AD template?", "Cancel Template", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (ans == DialogResult.OK)
            {
                m_parent.abort = true;
                this.Dispose();
            }

        }

        private void frmGroupTemplate_Load(object sender, EventArgs e)
        {
            txtSC1.Text = getRegValue("SITE");
            txtEnv1.Text = getRegValue("ENVIRONMENT");
            txtStTime1.Text = getRegValue("ST1");
            txtEndTime1.Text = getRegValue("ET1");
            txtStTime2.Text = getRegValue("ST2");
            txtEndTime2.Text = getRegValue("ET2");
            txtStTime3.Text = getRegValue("ST3");
            txtEndTime3.Text = getRegValue("ET3");
            txtException.Text = getRegValue("EXCEPTION");
            lblNoReboot.Text = getRegValue("NOREBOOT");
        }

        private string getRegValue(string name)
        {
            RegistryKey regKey = Registry.CurrentUser.OpenSubKey(@"SOFTWARE\Bondytech\SoftwareUpdateTool");
            
            string returnVal = "";

            switch (name)
            {
                case "SITE":
                    if (regKey.GetValue("SITE", null) != null) returnVal = regKey.GetValue("SITE").ToString();
                    break;
                case "ENVIRONMENT":
                    if (regKey.GetValue("ENVIRONMENT", null) != null) returnVal = regKey.GetValue("ENVIRONMENT").ToString();
                    break;
                case "ET1":
                    if (regKey.GetValue("ET1", null) != null) returnVal = regKey.GetValue("ET1").ToString();
                    break;
                case "ET2":
                    if (regKey.GetValue("ET2", null) != null) returnVal = regKey.GetValue("ET2").ToString();
                    break;
                case "ET3":
                    if (regKey.GetValue("ET3", null) != null) returnVal = regKey.GetValue("ET3").ToString();
                    break;
                case "ST1":
                    if (regKey.GetValue("ST1", null) != null) returnVal = regKey.GetValue("ST1").ToString();
                    break;
                case "ST2":
                    if (regKey.GetValue("ST2", null) != null) returnVal = regKey.GetValue("ST2").ToString();
                    break;
                case "ST3":
                    if (regKey.GetValue("ST3", null) != null) returnVal = regKey.GetValue("ST3").ToString();
                    break;
                case "EXCEPTION":
                    if (regKey.GetValue("EXCEPTION", null) != null) returnVal = regKey.GetValue("EXCEPTION").ToString();
                    break;
                case "NOREBOOT":
                    if (regKey.GetValue("NOREBOOT", null) != null) returnVal = regKey.GetValue("NOREBOOT").ToString();
                    break;
            }

            return returnVal;


        }

        private void btnClear_Click(object sender, EventArgs e)
        {

            txtSC1.Text = "";
            txtEnv1.Text = "";
            txtStTime1.Text = "";
            txtEndTime1.Text = "";
                delKey("ENVIRONMENT");
                delKey("ET1");
                delKey("ET2");
                delKey("ET2");
                delKey("ST1");
                delKey("ST2");
                delKey("ST3");
                delKey("SITE");
                delKey("EXCEPTION");
                delKey("NOREBOOT");
                Line2Disabled();
                Line3Disabled();
                
            
        }

        private void delKey(string Name)
        {

            RegistryKey rk = Registry.CurrentUser.OpenSubKey(@"SOFTWARE\Bondytech\SoftwareUpdateTool",true);
            try
            {
                rk.DeleteValue(Name);
            }
            catch
            {//ignore }

            }

        }

        private void txtEnv1_Leave(object sender, EventArgs e)
        {
            string strRegex = @"^[PRD|NPD]{3}$";
            // Instantiate the regular expression object.
            Regex r = new Regex(strRegex, RegexOptions.IgnoreCase);
            Match m = r.Match(txtEnv1.Text);
            if (m.Success)
            {
                lblExample.Text = (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-01-" + txtStTime1.Text + "-" + txtEndTime1.Text).ToUpper();
                lblNoReboot.Text= (txtSC1.Text + "-" + "SCCM " + txtEnv1.Text + "-xx-" + "NoReboot");
                enableLine2();
            }
            else
            {
                txtEnv1.Focus();
                MessageBox.Show("Environment must be 'NPD' or 'PRD'", "Incorrect environment code", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
            }
        }
    }
}
